<template>
	<TitleHeader :title="$t('pageTitle.clansList')" :header="$t('clansList.title')"></TitleHeader>
	<DZDisclaimer help round :content="$t('clansList.disclaimer.text')" />
	<div class="disclaimer" v-if="joinRequest">
		<p>
			{{ $t('clanPages.request.info') }}
			<a @click="goToClan(joinRequest.clan.id)" class="clan-name">{{ joinRequest.clan.name }}</a
			>.
		</p>
		<p>
			<a @click="cancelRequest(joinRequest)">{{ $t('clanPages.request.cancel') }}</a>
		</p>
	</div>
	<div class="wrapper">
		<table>
			<tbody>
				<tr>
					<th class="name">{{ $t('clansList.th.name') }}</th>
					<th class="leader">{{ $t('clansList.th.leader') }}</th>
					<th class="members">{{ $t('clansList.th.members') }}</th>
					<th class="date">{{ $t('clansList.th.date') }}</th>
				</tr>
				<tr class="select" @click="changePage(-1)" v-if="page > 1">
					<td class="pos" colspan="5" style="text-align: center">
						{{ $t('ranking.page.previous') }}
					</td>
				</tr>
				<tr
					v-for="clan in clansList"
					:key="clan.id"
					class="select"
					:class="(clan.id + 1) % 2 === 0 ? 'even' : ''"
					@click="goToClan(clan.id)"
				>
					<td class="name">
						{{ clan.name }}
					</td>
					<td class="leader other">
						{{ clan.leader.name }}
					</td>
					<td class="members other">
						{{ clan.members.length }}
					</td>
					<td class="date other">
						{{ dateToString(clan.creationDate) }}
					</td>
				</tr>
			</tbody>
			<tr class="select" @click="changePage(1)" :class="{ hidden: clansList.length < 20 }">
				<td class="pos" colspan="5" style="text-align: center">
					{{ $t('ranking.page.next') }}
				</td>
			</tr>
		</table>
		<div class="bottom-elements">
			<SearchEntity
				background
				entityType="clan"
				placeHolder="ranking.placeholder.searchClan"
				@entity="goToSearchedClan"
			/>
			<a class="button bottom-element" @click="search()">
				{{ $t('clansList.button.search') }}
			</a>
			<a v-if="!alreadyHasClan && canCreateClan" class="button bottom-element" @click="goToCreateClanPage()">
				{{ $t('clansList.button.create') }}</a
			>
			<div
				v-if="!alreadyHasClan && !canCreateClan"
				v-tippy="{
					content: cannotCreateText,
					theme: 'small'
				}"
			>
				<a class="button bottom-element disabled">
					{{ $t('clansList.button.create') }}
				</a>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';

import TitleHeader from '../components/utils/TitleHeader.vue';
import EventBus from '../events/index.js';
import { errorHandler } from '../utils/index.js';
import { ClanService } from '../services/index.js';
import { PlayerService } from '../services/index.js';
import { Clan, ClanJoinRequest } from '@drpg/prisma';
import { playerStore } from '../store';
import { CLAN_CREATE_MONEY, CLAN_CREATE_RANKING_POINTS } from '@drpg/core/constants';
import { formatNumber } from '../utils/formatText';
import { formatText } from '../utils/formatText.js';
import DZDisclaimer from '../components/common/DZDisclaimer.vue';
import SearchEntity from '../components/data/SearchEntity.vue';

export default defineComponent({
	name: 'ClansList',
	components: {
		SearchEntity,
		DZDisclaimer,
		TitleHeader
	},
	data() {
		return {
			clansList: {} as Array<Clan>,
			page: 1 as number,
			searchClanName: '' as string,
			joinRequest: undefined as ClanJoinRequest | undefined,
			playerStore: playerStore(),
			alreadyHasClan: true as boolean,
			canCreateClan: false as boolean,
			creationCost: formatNumber(CLAN_CREATE_MONEY, '.'),
			cannotCreateText: formatText(
				this.$t('clansList.cannot_create_info', {
					money: formatNumber(CLAN_CREATE_MONEY, '.'),
					points: CLAN_CREATE_RANKING_POINTS
				})
			)
		};
	},
	methods: {
		goToClan(_id: number): void {
			this.$router.push({ name: 'Clan', params: { id: _id } });
		},
		dateToString(date: string) {
			return new Date(date).toLocaleString('fr-FR');
		},
		goToCreateClanPage() {
			if (this.canCreateClan) {
				this.$router.push({
					name: 'CreateClan'
				});
			}
		},
		goToSearchedClan(c: Pick<Clan, 'id' | 'name'>): void {
			this.$router.push({ name: 'Clan', params: { id: c.id } });
		},
		goToHelp() {
			this.$router.push({
				name: 'Help'
			});
		},
		async search() {
			this.page = 1;
			if (this.searchClanName != '') {
				await this.getClansListByName();
			} else {
				await this.getClansList();
			}
		},
		async changePage(n: number) {
			this.page += n;
			await this.getClansList();
		},
		async getClansList(): Promise<void> {
			EventBus.emit('isLoading', true);
			try {
				this.clansList = await ClanService.getClansList(this.page);
				EventBus.emit('isLoading', false);
			} catch (err) {
				errorHandler.handle(err, this.$toast, this.$t);
				return;
			}
		},
		async getClansListByName() {
			EventBus.emit('isLoading', true);
			try {
				this.clansList = await ClanService.searchClansByName(this.searchClanName, this.page);
				EventBus.emit('isLoading', false);
			} catch (err) {
				errorHandler.handle(err, this.$toast, this.$t);
				return;
			}
		},
		async getPlayerJoinRequest() {
			try {
				this.joinRequest = await ClanService.getSelfJoinRequest();
			} catch (err) {
				if (err?.response?.status != 404) {
					errorHandler.handle(err, this.$toast, this.$t);
				}
				return;
			}
		},
		async cancelRequest(request: ClanJoinRequest) {
			EventBus.emit('isLoading', true);
			try {
				await ClanService.denyJoinClanRequest(request.id);
				this.joinRequest = undefined;
				EventBus.emit('refreshMoney', true);
				EventBus.emit('isLoading', false);
			} catch (err) {
				errorHandler.handle(err, this.$toast, this.$t);
				return;
			}
		}
	},
	async created(): Promise<void> {
		await this.getClansList();
		await this.getPlayerJoinRequest();
		this.alreadyHasClan = this.playerStore.clanId != undefined;
		if (!this.alreadyHasClan) {
			this.canCreateClan = await PlayerService.getCanCreateClan();
		}
	}
});
</script>

<style lang="scss" scoped>
.wrapper {
	width: 95%;
	align-self: center;
	table {
		width: 100%;
		margin-top: 10px;
		margin-bottom: 5px;
		margin-bottom: 10px;
		border: 2px solid #f3d6b1;
		background-color: #ecbd84;
		border-collapse: separate;
		border-spacing: 1px;
		tr {
			display: table-row;
			th {
				font-size: 8pt;
				letter-spacing: 0pt;
				text-shadow: 1px 1px 0px #356847;
				padding-left: 4px;
				padding-right: 4px;
				padding-bottom: 8px;
				height: 41px;
				vertical-align: bottom;
				color: #fffdba;
				text-transform: uppercase;
				font-weight: bold;
				letter-spacing: 1pt;
				text-align: left;
				white-space: nowrap;
				border: 1px solid #356847;
				background-color: #c64e36;
				background-image: url('../assets/background/table_header.webp');
				background-position: left bottom;
				max-width: 222px;
				&.name {
					width: 40%;
				}
				&.leader {
					width: 20%;
				}
				&.members {
					width: 10%;
				}
				&.date {
					width: 30%;
				}
			}
			td {
				font-size: 9pt;
				padding-right: 5px;
				padding-top: 1px;
				padding-bottom: 1px;
				color: #710;
				background-color: #f3ca92;
				border: 1px solid #c88f44;
				cursor: pointer;
				&.name {
					background-image: url('../assets/background/table_cell.webp');
					background-position: 0px 0px;
					padding-left: 1.2em;
				}
				&.pos {
					background-image: url('../assets/background/table_cell.webp');
					background-position: 0px 0px;
					padding-left: 1.2em;
				}
				&.other {
					padding-left: 1em;
					background-image: url('../assets/background/table_cell.webp');
					background-position: -10px 0px;
					max-width: 4px;
				}
			}
			&.even {
				td.name {
					background-image: url('../assets/background/table_cell_even.webp');
					background-position: 0px 0px;
				}
				td.other {
					background-image: url('../assets/background/table_cell_even.webp');
					background-position: -10px 0px;
				}
			}
			&.select:hover {
				td {
					color: white;
					border-color: #9a4029;
				}
			}
		}
	}
	.bottom-elements {
		width: 100%;
		display: flex;
		justify-content: space-around;
		flex-wrap: wrap;
		gap: 5px;
		.bottom-element {
			margin: auto 0;
		}
		.disabled {
			filter: grayscale(100%);
			&:hover {
				cursor: auto;
			}
		}
	}
}
input {
	width: 184px;
	height: 20px;
	padding-left: 8px;
	padding-right: 8px;
	padding-top: 2px;
	color: #ffee92;
	font-size: 9pt;
	font-weight: bold;
	border: none;
	background-image: url('../assets/design/form_field.webp');
	background-repeat: no-repeat;
	background-color: transparent;
}
.disclaimer {
	margin-top: 10px;
	margin-bottom: 10px;
	padding: 5px;
	padding-left: 5px;
	padding-left: 20px;
	color: #fce3bc;
	font-size: 10pt;
	background-color: #bc683c;
	background-position: 5px 8px;
	background-repeat: no-repeat;
	a {
		color: #fff192;
		cursor: pointer;
		text-decoration: underline;
	}
}
.hidden {
	display: none !important;
}
</style>
